(*
** simply typed \lambda calculus
*)

(*
** Types 
*)

(* mu[Ty:Set](ty0 : Ty, arr : Ty -> Ty -> Ty) *)

[Ty : Set]
[ty0 : Ty]
[arr : Ty -> Ty -> Ty];
[RecTy : {P:Ty->Type}(P ty0) ->
	    ({s:Ty}(P s)->{t:Ty}(P t) -> (P (arr s t)))
	 -> ({s:Ty}P s)];

[[P:Ty->Type][f0:P ty0][f1:{s:Ty}(P s)->{t:Ty}(P t) -> (P (arr s t))]
 [s,t:Ty]
   RecTy P f0 f1 ty0 ==> f0
|| RecTy P f0 f1 (arr s t) ==> f1 s (RecTy P f0 f1 s)
				  t (RecTy P f0 f1 t)];

[RecTyN[P|Type] = RecTy ([_:Ty]P)
 : P->(Ty->P->Ty->P->P)->Ty->P];

(* 
** Contexts 
*)

[Con = Vec Ty]
[empty = v_nil Ty : Con zero];

(* 
** Derivations 
*)

(* mu[Der:{n|Nat}(Con n)->Tm->Ty->Set](
	Var : {n|Nat}{G:Con n}{i:Fin n}
		Der G (var (Fin2Nat i)) (v_nth i G)
	App : {n|Nat}{G|Con n}{s,t|Ty}{M,N|Tm}
		(Der G M (arr s t))
		-> (Der G N s)
		-> (Der G (app M N) t)
	Lam :  {n|Nat}{G|Con n}{s,t|Ty}{M|Tm}
		(Der (v_cons s G) M t)
		-> (Der G (lam M) (arr s t))
*)

$[Der : {n|Nat}(Con n)->Tm->Ty->Set]
$[Var : {n|Nat}{G:Con n}{i:Fin n}
		Der G (var (Fin2Nat i)) (v_nth i G)]
$[App : {n|Nat}{G|Con n}{s,t|Ty}{M,N|Tm}
		(Der G M (arr s t))
		-> (Der G N s)
		-> (Der G (app M N) t)]
$[Lam : {n|Nat}{G|Con n}{s,t|Ty}{M|Tm}
		(Der (v_cons s G) M t)
		-> (Der G (lam M) (arr s t))]
$[RecDer : {P:{n|Nat}{G|Con n}{M|Tm}{s|Ty}(Der G M s)->Type}
	({n|Nat}{G:Con n}{i:Fin n}P (Var G i))
	-> ({n|Nat}{G|Con n}{s,t|Ty}{M,N|Tm}
		{d1:Der G M (arr s t)}(P d1) 
		-> {d2:Der G N s}(P d2)
		-> P (App d1 d2))
	-> ({n|Nat}{G|Con n}{s,t|Ty}{M|Tm}
		{d:Der (v_cons s G) M t}(P d)
		-> P (Lam d))
	-> {n|Nat}{G|Con n}{M|Tm}{s|Ty}{d:Der G M s}P d];

[[P:{n|Nat}{G|Con n}{M|Tm}{s|Ty}(Der G M s)->Type]
 [Var_ : {n|Nat}{G:Con n}{i:Fin n}P (Var G i)]
 [App_ : {n|Nat}{G|Con n}{s,t|Ty}{M,N|Tm}
		{d1:Der G M (arr s t)}(P d1) 
		-> {d2:Der G N s}(P d2)
		-> P (App d1 d2)]
 [Lam_ : {n|Nat}{G|Con n}{s,t|Ty}{M|Tm}
		{d:Der (v_cons s G) M t}(P d)
		-> P (Lam d)]
 [n:Nat][G:Con n][M,N|Tm][s,t:Ty][i:Fin n][d1:Der G M (arr s t)]
 [d2:Der G N s][d:Der (v_cons s G) M t]
   RecDer P Var_ App_ Lam_ (Var G i) ==> (Var_ G i)
|| RecDer P Var_ App_ Lam_ (App d1 d2) ==> 
	App_ d1 (RecDer P Var_ App_ Lam_ d1)
	     d2 (RecDer P Var_ App_ Lam_ d2)
|| RecDer P Var_ App_ Lam_ (Lam d) ==>
	Lam_ d (RecDer P Var_ App_ Lam_ d)];

[RecDerN[P:{n|Nat}(Con n)->Tm->Ty->Type] = 
	RecDer [n|Nat][G|Con n][M|Tm][s|Ty][_:Der G M s]P G M s
: ({n|Nat}{G:Con n}{i:Fin n}P G (var (Fin2Nat i)) (v_nth i G))
->({n|Nat}{G|Con n}{s,t|Ty}{M,N|Tm}(Der G M (arr s t))->(P G M (arr s t))
	->(Der G N s)->(P G N s)->P G (app M N) t)
->({n|Nat}{G|Con n}{s,t|Ty}{M|Tm}(Der (v_cons s G) M t)->(P (v_cons s G) M t)
	->P G (lam M) (arr s t))
->{n|Nat}{G|Con n}{M|Tm}{s|Ty}(Der G M s)->P G M s
];

